#include <iostream>
using namespace std;

class Base {
  public:
    void print();
};

class Derived1 : public Base {
  public:
    virtual void print();
};

class Derived2 : public Derived1 {
  public:
    void print();
};

void Base::print() {
  cout << "Base class" << endl;
}

void Derived1::print() {
  cout << "Derived1 class" << endl;
}

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  Base *ptr = new Base();
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  ptr->print();   // prints "Base class"
  ptr1->print();  // prints "Base class" -- not virtual in Base
  ptr2->print();  // prints "Base class" -- not virtual in Base

  Derived1 *d1ptr = new Derived1();
  Derived1 *d1ptr2 = new Derived2();
  Derived2 *d2ptr = new Derived2();

  d1ptr->print();   // prints "Derived1 class"
  d1ptr2->print();  // prints "Derived2 class" -- IS virtual in Derived1
  d2ptr->print();   // prints "Derived2 class" 

  return 0;
}


