#include <iostream>
using namespace std;

class Base {
  public:
    virtual void print() = 0;
};

class Derived1 : public Base {
  public:
    void print();
};

class Derived2 : public Derived1 {
  public:
    void print();
};

// Base::print is a pure virtual function

void Derived1::print() {
  cout << "Derived1 class" << endl;
}

void Derived2::print() {
  cout << "Derived2 class" << endl;
}

int main() {
  // Base *ptr = new Base();  Base is now abstract
  Base *ptr1 = new Derived1();
  Base *ptr2 = new Derived2();

  // ptr->print();   // prints "Base class" -- Base is abstract
  ptr1->print();  // prints "Derived1 class"
  ptr2->print();  // prints "Derived2 class"

  return 0;
}


